<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>TASK212.40B</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>   
    <style>
        .picture-cove {
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>
<body>
    <div class="container-fluid picture-cove"></div>
    <div class="container">
        <div class="row">
            <div class="col-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Username</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-username" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Firstname</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-first-name" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Lastname</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-last-name" class="form-control">
                    </div>
                </div>
            </div>
            <div class="col-4 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <button onclick="onBtnNutNemClick()" type="button" class="btn-block btn btn-success">Ném</button>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-new-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <p id="p-loi-nhan-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-prize" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row text-center form-group">
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25" onclick="onBtnDiceHistoryClick()">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-12">
                <table id="history-dice-table" class="table table-striped table-hover border">
                   <thead>
                         <tr>
                            <th>Lượt</th>
                            <th>Dice</th>
                        </tr>
                   </thead>
                   <tbody  id="history-dice-tbody">

                   </tbody>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
     "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
     //base url
    const gBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_ROW_TABLE = -1;
    // hằng số số thứ tự các cột
    const gCOLUMN_DICE_HISTORY = 0;
    const gCOLUMN_DICE = 1;
   
         // khai báo đối tượng
         var gUser = {
            username: "",
            firstname: "",
            lastname: ""
        }

     /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm xử lý sự kiện khi ấn nút ném (Subtask1)
    function onBtnNutNemClick() {
    
        // B1: thu thập dữ liệu của đối tượng user (subtak1)
        thuThapDuLieuUser(gUser);
        // B2: validate (kiểm tra) dữ liệu (subtask1)
        var vDuLieuHopLe = validateDuLieuUser(gUser);
        if (vDuLieuHopLe) {
             // create a request
            var vXmlHttpDice = new XMLHttpRequest();
            // B3: call Api server (subtask 2)
            callApiNewDice(vXmlHttpDice, gUser);
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    console.log(vXmlHttpDice.responseText);
                    // B4: hiển thị dữ liệu
                    hienThiResponse(vXmlHttpDice);
                }
            }
        }
    }

    // HÀM XỬ LÝ SỰ KIỆN KHI ẤN NÚT DICE HISTORY
    function onBtnDiceHistoryClick() {
        console.log("%c Nút Dice History được ấn", "color:blue");
        // B1: thu thập dữ liệu của đối tượng user (subtak1)
        thuThapDuLieuUser(gUser);
        // B2: validate (kiểm tra) dữ liệu (subtask1)
        var vDuLieuHopLe = validateDuLieuUser(gUser);
        if (vDuLieuHopLe) {
             // create a request
            var vXmlHttpDiceHistory = new XMLHttpRequest();
            // B3: call Api để nhận lịch sử tung xúc xắc
            callApiDiceHistory(vXmlHttpDiceHistory, gUser);
            vXmlHttpDiceHistory.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpDiceHistory.responseText);
                     // B4: hiển thị dữ liệu
                     hienThiResponseDiceHistory(vXmlHttpDiceHistory);
                }
            }
            
        }
    }

         /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu (subtask1)(b1)
    function thuThapDuLieuUser(paramUser) {
        var vInputUserName = document.getElementById("inp-username");
        var vInputFirstName = document.getElementById("inp-first-name");
        var vInputLastName = document.getElementById("inp-last-name");

        paramUser.username = vInputUserName.value.trim();
        paramUser.firstname = vInputFirstName.value.trim();
        paramUser.lastname = vInputLastName.value.trim();    
    }
    // Hàm kiểm tra dữ liệu (subtask1)(b2)
    function validateDuLieuUser(paramUser) {
        if ( paramUser.username == "") {
            alert("Bạn cần nhập Username!!!")
            return false;
        }
        if ( paramUser.firstname == "") {
            alert("Bạn cần nhập Firstname!!!")
            return false;
        }
        if ( paramUser.lastname == "") {
            alert("Bạn cần nhập Lastname!!!")
            return false;
        }
        return true;
    }
    // Hàm gọi Api NewDice
    function callApiNewDice(paramXmlHttpDice, paramUser) {
        // thêm mới dice (POST)
        paramXmlHttpDice.open("POST", gBASE_URL + "/dice", true);
        paramXmlHttpDice.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttpDice.send(JSON.stringify(paramUser));  //chuyển Json object sang string
    }
    // Hàm hiển thị 
    function hienThiResponse(paramXmlHttpDice) {
         //chuyển JSON(response kết quả trả về) thành object(subtask4)
         var vResponseObject = JSON.parse(paramXmlHttpDice.responseText);
         console.log(vResponseObject);

         //get result dice (hiển thị mặt xúc xắc mới) (subtask5)
        var vNewDice = vResponseObject.dice;
        console.log("dice result: " + vNewDice);
        //gọi hàm hiển thị dice (subtask5)
        changeNewDice(vNewDice);
        //gọi hàm hiển thị lời nhắn (subtask5)
        changeNewLoiNhan(vNewDice);

        //gọi hàm hiển thị voucher (subtask6)
        changeVoucherId(vResponseObject);

         //gọi hàm hiện ảnh phần thưởng (subtask7)
         changeGift(vResponseObject);
    }

    // HÀM HIỂN THỊ NEW DICE
    function changeNewDice(paramNewDice) {
        "use strict";
            var vImgDice = document.getElementById("img-new-dice");
            switch(paramNewDice) {
                case 1:
                    vImgDice.src = "LuckyDiceImages/1.png";
                    break;
                case 2:
                    vImgDice.src = "LuckyDiceImages/2.png";
                    break;
                case 3:
                    vImgDice.src = "LuckyDiceImages/3.png";
                    break;
                case 4:
                    vImgDice.src = "LuckyDiceImages/4.png";
                    break;
                case 5:
                    vImgDice.src = "LuckyDiceImages/5.png";
                    break;
                case 6:
                    vImgDice.src = "LuckyDiceImages/6.png";
                    break;
            }
    }
    // HÀM HIỂN THỊ LỜI NHẮN MỚI
    function changeNewLoiNhan(paramNewDice) {
        "use strict";
            var vLoiNhan = document.getElementById("p-loi-nhan-dice");
            if (paramNewDice < 4) {
                vLoiNhan.innerHTML = ("Chúc bạn may mắn lần sau !!!");
            }
            else {
                vLoiNhan.innerHTML = ("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
            }
    }
    // HÀM NHẬN VOUCHER
    function changeVoucherId(paramResponseVoucher) {
        "use strict";
            var vVoucherId = document.getElementById("p-voucher-id");
            var vVoucherPercent = document.getElementById("p-voucher-percent");
            
            if (paramResponseVoucher.voucher != null) {
                vVoucherId.innerHTML = paramResponseVoucher.voucher.maVoucher;
                vVoucherPercent.innerHTML = paramResponseVoucher.voucher.phanTramGiamGia + "%";
            }
            else {
                vVoucherId.innerHTML = "";
                vVoucherPercent.innerHTML = "";
            }
    }
    // HÀM HIỂN THỊ PHẦN THƯỞNG
    function changeGift(paramResponePrize) {
        var vImgPrize = document.getElementById("img-prize");
            var vTenPhanThuong = paramResponePrize.prize;
            switch(vTenPhanThuong) {
                case "Mũ":
                    vImgPrize.src = "LuckyDiceImages/hat.jpg";
                    break;
                case "Áo":
                    vImgPrize.src = "LuckyDiceImages/t-shirt.jpg";
                    break;
                case "xe máy":
                    vImgPrize.src = "LuckyDiceImages/xe-may.jpg"
                    break;
                case "ô tô":
                    vImgPrize.src = "LuckyDiceImages/car.jpg";
                    break;
                default:
                    vImgPrize.src = "LuckyDiceImages/no-present.jpg";
            }
    }


    // HÀM GỌI CALL API KHI ẤN NÚT DICE HISTORY
    function callApiDiceHistory(paramXmlHttpDiceHistory, paramUser) {
        paramXmlHttpDiceHistory.open("GET", gBASE_URL + "/dice-history?username=" + paramUser.username, true);
        paramXmlHttpDiceHistory.send();
    }
    // HÀM HIỂN THỊ DICE HISTORY
    function hienThiResponseDiceHistory(paramXmlHttpDiceHistory) {
        //chuyển JSON(response kết quả trả về) thành object(subtask4)
        var vResponseDiceHistoryObject = JSON.parse(paramXmlHttpDiceHistory.responseText);
         console.log(vResponseDiceHistoryObject);

         var vDiceHistoryTable = document.getElementById("history-dice-tbody");
        // xóa trắng bảng
         vDiceHistoryTable.innerHTML = "";
         for (var i = 0; i < vResponseDiceHistoryObject.dices.length; i++) {
            var vUser = vResponseDiceHistoryObject[i];
            // tạo thêm dòng mới
            var vNewRow = vDiceHistoryTable.insertRow(gEND_ROW_TABLE);
            // thêm cột
            var vLuotDiceHistoryCell = vNewRow.insertCell(gCOLUMN_DICE_HISTORY);
            var vDiceCell = vNewRow.insertCell(gCOLUMN_DICE);
             // điền dữ liệu cho
            vLuotDiceHistoryCell.innerHTML = i+1;
            vDiceCell.innerHTML = vResponseDiceHistoryObject.dices[i];
         }
    }

</script>
</html>
